set defa to e:\vfpserv\registr
#include registr.h
_screen.fontname="Courier"
_screen.fontsize=10

set date to german
set century on

oRegman = newobject("RegistrMan", "registr.vcx")
with oRegMan
  .Open(HKEY_CURRENT_USER)
  ?"LastTime:", .tLastTime
  ?"SubKeys:",.nSubKeys
  for i=0 to .nSubKeys-1
    ?.SubKeys(i)," ", .tLastTime
  endfor
  .close

wait window "One minute..."

  cKey = "MyKey"
  if .create(HKEY_CURRENT_USER, cKey)

    ?.SetValue("First", REG_SZ, "String")
    ?.SetValue("Second", REG_DWORD, 1234)
    ?.SetValue("Third", REG_DWORD_BIG_ENDIAN, 1234)
    ?.SetValue("Fourth", REG_BINARY, "Reg_Binary")
	dime aaa(4)
	aaa(1)=0xFF
	aaa(2)=0xFF00
	aaa(3)=0xFF0000
	aaa(4)=0x7F000000
    ?.SetValue("Fifth", REG_BINARY, @aaa, 4)
	aaa(1)="First line"
	aaa(2)="Second line"
	aaa(3)="Third line"
	aaa(4)="Fourth line"
    ?.SetValue("Sixth", REG_MULTI_SZ, @aaa, .T.)

    .Close()

    .Open(HKEY_CURRENT_USER, cKey)
    ?"Parameters: ", .nValues
    for i=0 to .nValues-1
    ?.Values(i), .nType
    endfor

wait window "One minute..."

    ?"First", .GetValue("First")
    ?"Second", .GetValue("Second")
    ?"Third", .GetValue("Third")
	cBuf =  .GetValue("Fourth")
    ?"Fourth", cBuf
    for ii=1 to len(cBuf)
      ?? " ", hex(asc(substr(cBuf, ii, 1)))
    endfor

	dime bbb(1)
    ?"Fifth", .GetValue("Fifth", @bbb, 4)
	?
	for ii=1 to alen(bbb)
	  ??allt(str(ii))+":",hex(bbb(ii))," "
	endfor
    ?"Sixth", .GetValue("Sixth")
    ?.GetValue("Sixth", @bbb)
	?
	for ii=1 to alen(bbb)
	  ??bbb(ii)
	endfor

	?"DelValue ", .DeleteValue("Fourth"), .nError

wait window "One minute..."

	cKey = "MyKey\MySubKey\MySubSubKey"
    if .create(HKEY_CURRENT_USER, cKey)
      ?"DelKey", .DeleteKey("MySubSubKey"), .nError
      cKey = "MyKey\MySubKey"
	  ?.open(HKEY_CURRENT_USER, cKey)
      ?"DelKey", .DeleteKey("MySubSubKey"), .nError
      ?.FlushKey()
    endif
  endif
  ?"Error ", .nError
  .Close()
  .release
endwith
wait window "Finish!"
return

function Hex
lParameters tnNumber, tnBase

local lnNumber, lnBase, lcRes
lnNumber=tnNumber
lnBase=iif(empty(tnBase),16,tnBase)
lcRes=''
do while lnNumber>0
  lnDigit=mod(lnNumber, lnBase)
  lnNumber=int(lnNumber/lnBase)
  lcDigit=iif(lnDigit<10,chr(asc('0')+lnDigit),chr(asc('A')+lnDigit-10))
  lcRes=lcDigit+lcRes
enddo
return lcRes
